REBOL [
    File: %conf.r
    Date: 2-Aug-2002
    Title: "configuration file"
]

port: 80

;-- modules --
; map requests like "path/path/path/file" to a special handler that is
; called to process the request.
; wildcards allowed (? any-char, * any-string)
; the first matching handler will be used. 
; so be careful, the default-handler (*/*) is always the last in the block
;
; listed handlers must be valid rebol scripts residing in %./modules/
;

modules: [
  ;uri-pattern   ;handler-file
  "/secret/*"    %secret.r
  
  "*/"           %index.r
  "*.r"          %embedded.r
  "*/*"          %passthru.r
]

content-types: [
  ;extension   ;mime-type
  ".png"       "image/png"    
  ".jpg"       "image/jpeg"
  ".jpeg"      "image/jpeg"
  ".gif"       "image/gif"
]