REBOL [
  Title:  "index"
  File:   %index.r
  Author: "vpavlu"
  Date:   3-Aug-2002
  Version: 0.0.1
  History: [
    0.0.1 {initial version}
  ]
]

path: dirname? r/request/script-name

;get files and sort em
files: make block! 20
foreach file read %./ [
  repend files [ info? rejoin [ document-root path file ] to-string file ]
]

sorting: to-string any [ r/request/query-string "N=A"]
by: none
order:  true
parse sorting [
  [ "N=" | "M=" (by: 'date) | "S=" (by: 'size) ]
  [ "A"  | "D" (order: no) ]
]

either order [
  either none? by
   [sort/skip/compare files 2 2]
   [sort/skip/compare files 2 func [a b][(get in a by) < (get in b by)] ]
][
  either none? by
   [sort/skip/compare/reverse files 2 2]
   [sort/skip/compare/reverse files 2 func [a b][(get in a by) < (get in b by)] ]
]
;end of sort


;create output
r/content: make string! 1024
r/content: rejoin [
  {<html><head><title>Index of } r/request/script-name {</title></head>
<body bgcolor="#ffffff"><h2>Index of } r/request/script-name {</h2><pre>}
{<a href="} server/location path either = sorting "N=A" [ "?N=D" ][ "?N=A" ] {">Name</a>                            }
{<a href="} server/location path either = sorting "M=A" [ "?M=D" ][ "?M=A" ] {">Last Modified</a>            }
{<a href="} server/location path either = sorting "S=A" [ "?S=D" ][ "?S=A" ] {">Size</a>
_____________________________________________________________

}]

append r/content rejoin [ {<a href="} server/location first split-path path {">Parent directory</a>} crlf ]
foreach [info file] files [
  either (length? file) > 30 [ fname: join copy/part file 28 ".." ][ fname: file ]
  
  space1: copy ""
  insert/dup space1 " " (32 - length? fname)
  
  if (length? date-string: to-string info/date/date) < 11 [ insert date-string " " ]
  if (length? hh:   to-string first  info/date/time) <  2 [ insert hh "0" ]
  if (length? mm:   to-string second info/date/time) <  2 [ insert mm "0" ]
  
  replace/all date-string "-" " "
  
  either = 'directory info/type [
    file-size: " - "
  ][
    size: "B"
    if (file-size: info/size) > 1024 [
      size: "KB"
      if (file-size: to-integer .5 + (file-size / 1024)) > 1024 [ 
        size: "MB"
        file-size: to-integer .5 + (file-size / 1024)
      ]
    ]
    file-size: join to-string file-size size
    if size = "B" [ insert file-size " " ]
  ]
    
  space2: copy ""
  insert/dup space2 " " (12 - length? file-size)
  
  append r/content rejoin [ 
    {<a href="} server/location path file {">} fname {</a>} space1
    date-string " " hh ":" mm space2
    file-size crlf
  ]
]

append r/content {_____________________________________________________________</pre></body></html>}