rebol [
  title:  "simple output buffering routines"
  date:   3-jun-2002
  author: "vpavlu"
  ]
; 2-jun-2002  vpavlu  mehrfaches aufrufen hinzugefgt (111122223333344433221111)
; 3-jun-2002  vpavlu  --"-- (debugging kaskadierender calls); jetzt passts

output-buffer: make object! [
  sys-prin:  :prin
  sys-print: :print
  buf-prin:
  buf-print: func [ s ][ if found? s [ repend data s ] do [] ]

  opened: 0
  data: make string! 2048
  stack: make block! 10
]
  
output-buffer-open: func [ "starts (a new?) output buffer"
                           /local
                          ][
  either zero? output-buffer/opened [
    echo:
    prin:  get in output-buffer 'buf-prin
    print: get in output-buffer 'buf-print
  ][
    append output-buffer/stack copy output-buffer/data
    clear output-buffer/data
  ]    
  output-buffer/opened: add output-buffer/opened 1
]

output-buffer-close: func [ /local buf][
  if greater? output-buffer/opened 0 [
    output-buffer/opened: subtract output-buffer/opened 1
    
    buf: copy output-buffer/data
    clear output-buffer/data
    
    either zero? output-buffer/opened [
      echo: none
      prin:  get in output-buffer 'sys-prin
      print: get in output-buffer 'sys-print
    ][
      output-buffer/data: last output-buffer/stack
      remove back tail output-buffer/stack
    ]
    return buf
  ]
  throw "output buffer closed without opening it"
]
